###########################################################################
# $Id: StorageFile.p,v 1.10 2014/10/14 23:29:57 misha Exp $
# implementation for store data into files


@CLASS
StorageFile


@USE
Storage.p


@BASE
Storage



###########################################################################
@auto[]
$sClassName[StorageFile]

$hDefault[
	$.uExpires[^date::create(2037;12;31;23;59;59)]
	$.sDir[/../$MAIN:DATA_DIR/$sClassName]
]
$sInfoFileExt[idx]
$hOption[
	$.encloser["]
]



###########################################################################
@create[sStorageName;hParam]
^BASE:create[$sStorageName;$hParam]



###########################################################################
# private

@_init[hParam][result]
$self.sDataDir[^if(def $hParam.sDataDir){$hParam.sDataDir}{$hDefault.sDir}]



@_open[][result]
^if(!def $self.sStorageDir){
	$self.sStorageDir[$self.sDataDir/$self.sStorageName]
}



@_get[sKey][sFName]
$sFName[^self._key2fname[$sKey]]
$result[^self._load_data[$sFName;$sKey;^self._load_info[$sFName]]]



@_set[sKey;hValue][result;sFName]
$sFName[^self._key2fname[$sKey]]
^self._delete_files[$sFName]
^self._save_info[$sFName;$sKey;$hValue]
^self._save_data[$sFName;$sKey;$hValue]



@_delete[sKey][result]
^self._delete_files[^self._key2fname[$sKey]]



@_cleanup[][result;t;sFName;hInfo]
$t[^file:list[$self.sStorageDir;\.$self.sInfoFileExt^$]]
^t.menu{
	$sFName[^file:justname[$t.name]]
	$hInfo[^self._load_info[$sFName]]
	^if(!def $hInfo.sType){
		^self._delete_files[$sFName]
	}
}
# todo@ delete data files without indices



@_load_data[sFName;sKey;hInfo][sFSpec;f]
$result[^hash::create[$hInfo]]
^if(def $result.sType){
	$sFSpec[^self._get_data_fspec[$sFName]]
	$result.uValue[^switch[$result.sType]{
		^case[table;hash]{^table::load[$sFSpec;$hOption]}
		^case[file]{^file::load[binary;$sFSpec]}
		^case[xdoc;xnode]{^xdoc::load[$sFSpec]}
		^case[DEFAULT]{$f[^file::load[text;$sFSpec]]^taint[as-is][$f.text]}
	}]
}



@_save_data[sFName;sKey;hValue][result;sFSpec;s]
$sFSpec[^self._get_data_fspec[$sFName]]
^switch[$hValue.sType]{
	^case[table;hash]{^hValue.uValue.save[$sFSpec;$hOption]}
	^case[file]{^hValue.uValue.save[binary;$sFSpec]}
	^case[DEFAULT]{$s[$hValue.uValue]^s.save[$sFSpec]}
}



@_save_info[sFName;sKey;hValue][uExpires;t]
^if(def $hValue.uExpires && $hValue.uExpires != 0){
	$uExpires[^if($hValue.uExpires is "date"){$hValue.uExpires}{^date::now($hValue.uExpires)}]
}{
	$uExpires[$hDefault.uExpires]
}
$t[^table::create{type^#09expires^#09key^#0A$hValue.sType^#09^uExpires.sql-string[]^#09^taint[$sKey]}]
^try{
	^t.save[^self._get_info_fspec[$sFName]]
}{
	$exception.handled(true)
}
$result[]



@_load_info[sFName][t;sFSpec]
$result[$.uValue[]]
$sFSpec[^self._get_info_fspec[$sFName]]
^if(-f $sFSpec){
	$t[^table::load[$sFSpec]]
	^if(^date::create[$t.expires] > ^date::now[]){
		$result.sType[$t.type]
	}{
		^self._delete_files[$sFName]
	}
}


@_key2fname[sKey][result]
^self._normalize[$sKey]



@_get_info_fspec[sFName][result]
^self._get_fspec[$sFName;$self.sInfoFileExt]



@_get_data_fspec[sFName][result]
^self._get_fspec[$sFName]



@_get_fspec[sFName;sExt]
$result[$self.sStorageDir/$sFName^if(def $sExt){.$sExt}]



@_delete_files[sFName][result]
^self._delete_file[^self._get_data_fspec[$sFName]]
^self._delete_file[^self._get_info_fspec[$sFName]]




@_delete_file[sFSpec][result]
^if(-f $sFSpec){
	^try{
		^file:delete[$sFSpec]
	}{
		$exception.handled(true)
	}
}



@_convert2saveable[sType;uValue]
$result[^switch[$sType]{
	^case[table;file;xdoc]{$uValue}
	^case[xnode]{^Convert:xnode2xdoc[$uValue]}
	^case[hash]{^Convert:hash2table[$uValue]}
	^case[DEFAULT]{^Convert:object2str[$uValue;$sType]}
}]



@_convert2object[sType;uValue][result]
^switch[$sType]{
	^case[string;table;xdoc;file]{$result[$uValue]}
	^case[double;int;bool]{$result(^Convert:str2object[$sType;$uValue])}
	^case[hash]{$result[^Convert:table2hash[$uValue]]}
	^case[xnode]{$result[^Convert:xdoc2xnode[$uValue]]}
	^case[DEFAULT]{$result[^Convert:str2object[$sType;$uValue]]}
}


