###########################################################################
# $Id: StorageSQL.p,v 1.12 2007-12-04 09:46:55 misha Exp $
# implementation for store data into SQL table
#
# limitation:
#	- the size of value can't be more then 65535 bytes


@CLASS
StorageSQL


@USE
StorageStr.p


@BASE
StorageStr



###########################################################################
@auto[]
$sClassName[StorageSQL]

$hDefault[
	$.uExpires[^date::create(2037;12;31;23;59;59)]

	$.sPKColumn[uid]
	$.sTypeColumn[type]
	$.sExpiresColumn[expires]
	$.sValueColumn[value]
	$.sKeyColumn[name]
]
#end @auto[]



###########################################################################
@create[sStorageName;hParam]
^BASE:create[$sStorageName;$hParam]

$iMaxDataLenght(65534)
#end @create[]



###########################################################################
# private

@_init[hParam][sQuote]
^if(!def $hParam.oSql){
	^self._throw[^$.oSql must be specified.]
}
$self.oSql[$hParam.oSql]

$sQuote[$oSql.sQuoteChar]
$sTable[${sQuote}${sStorageName}$sQuote]
$sPKColumn[${sQuote}^if(def $hParam.sPKColumn){$hParam.sPKColumn}{$hDefault.sPKColumn}$sQuote]
$sTypeColumn[${sQuote}^if(def $hParam.sTypeColumn){$hParam.sTypeColumn}{$hDefault.sTypeColumn}$sQuote]
$sExpiresColumn[${sQuote}^if(def $hParam.sExpiresColumn){$hParam.sExpiresColumn}{$hDefault.sExpiresColumn}$sQuote]
$sValueColumn[${sQuote}^if(def $hParam.sValueColumn){$hParam.sValueColumn}{$hDefault.sValueColumn}$sQuote]
$sKeyColumn[${sQuote}^if(def $hParam.sKeyColumn){$hParam.sKeyColumn}{$hDefault.sKeyColumn}$sQuote]
$result[]


@_get[sKey][tData]
^self._cleanup[]
$tData[^oSql.table{
	SELECT
		$sTypeColumn AS sType,
		$sValueColumn AS uValue
	FROM
		$sTable
	WHERE
		$sPKColumn = '^self._normalize[$sKey]'
}[;
	$.bCache(0)
]]
$result[
	$.sType[$tData.sType]
	$.uValue[^taint[as-is][$tData.uValue]]
]


@_set[sKey;hValue][uExpires]
^self._check_size[;$hValue]
^self._delete[$sKey]
^if(def $hValue.uExpires && $hValue.uExpires != 0){
	$uExpires[^if($hValue.uExpires is "date"){$hValue.uExpires}{^date::now($hValue.uExpires)}]
}{
	$uExpires[$hDefault.uExpires]
}
^oSql.void{
	INSERT INTO $sTable (
		$sPKColumn,
		$sTypeColumn,
		$sValueColumn,
		$sExpiresColumn,
		$sKeyColumn
	) VALUES (
		'^self._normalize[$sKey]',
		'$hValue.sType',
		/**$sValueColumn**/'$hValue.uValue',
		'^uExpires.sql-string[]',
		/**$sKeyColumn**/'$sKey'
	)
}
$result[]


@_delete[sKey]
^oSql.void{
	DELETE FROM
		$sTable
	WHERE
		$sPKColumn = '^self._normalize[$sKey]'
}
$result[]


@_cleanup[]
^oSql.void{
	DELETE FROM
		$sTable
	WHERE
		$sExpiresColumn < ^oSql.now[]
}
$result[]


