###########################################################################
# $Id: StorageStr.p,v 1.8 2007-12-04 09:46:55 misha Exp $
# base class for all children whose can store only strings

# limitation:
#	- \t and \n chars not acceptable in table/hash fields for now

@CLASS
StorageStr


@USE
Storage.p


@BASE
Storage



###########################################################################
@auto[]
$hSeparator[
	$.sField[|]
]
#end @auto[]



###########################################################################
@create[sStorageName;hParam]
^BASE:create[$sStorageName;$hParam]
#end @create[]



@_pack[hValue]
$result[${hValue.sType}${hSeparator.sField}$hValue.uValue]


@_unpack[sValue]
^if(def $sValue){
	^sValue.match[^^([^^$hSeparator.sField]+)\${hSeparator.sField}(.+)^$][x]{
		$result[
			$.sType[$match.1]
			$.uValue[^taint[as-is][$match.2]]
		]
	}
}
^if(!def $result){
	$result[^hash::create[]]
}


@_convert2saveable[sType;uValue]
$result[^Convert:object2str[$uValue;$sType]]


@_convert2object[sType;uValue]
$result[^Convert:str2object[$sType;$uValue]]


@_check_size[sKey;hValue][iValueSize]
$iValueSize(^if(def $hValue.uValue){^sValue.length[]}{0})
^if(^sKey.length[] + $iValueSize > $iMaxDataLenght){
	^self._throw[Data for storage is too long. Key length + value length > ${iMaxDataLenght}.]
}
$result[]
